package service

import (
	"context"
	"github.com/gofiber/fiber/v2"
	"github.com/minio/minio-go/v7"
	"github.com/rs/zerolog"
	"go-humas-be/app/module/ppid_data_files/mapper"
	"go-humas-be/app/module/ppid_data_files/repository"
	"go-humas-be/app/module/ppid_data_files/request"
	"go-humas-be/app/module/ppid_data_files/response"
	minioStorage "go-humas-be/config/config"
	"go-humas-be/utils/paginator"
	"io"
	"log"
	"math/rand"
	"mime"
	"path/filepath"
	"strconv"
	"strings"
	"time"
)

// PpidDataFilesService
type ppidDataFilesService struct {
	Repo         repository.PpidDataFilesRepository
	Log          zerolog.Logger
	MinioStorage *minioStorage.MinioStorage
}

// PpidDataFilesService define interface of IPpidDataFilesService
type PpidDataFilesService interface {
	All(req request.PpidDataFilesQueryRequest) (ppidDataFiles []*response.PpidDataFilesResponse, paging paginator.Pagination, err error)
	Show(id uint) (ppidDataFiles *response.PpidDataFilesResponse, err error)
	Save(c *fiber.Ctx) error
	Update(id uint, req request.PpidDataFilesUpdateRequest) (err error)
	Delete(id uint) error
	Viewer(c *fiber.Ctx, filename string) error
}

// NewPpidDataFilesService init PpidDataFilesService
func NewPpidDataFilesService(repo repository.PpidDataFilesRepository, log zerolog.Logger, minioStorage *minioStorage.MinioStorage) PpidDataFilesService {

	return &ppidDataFilesService{
		Repo:         repo,
		Log:          log,
		MinioStorage: minioStorage,
	}
}

// All implement interface of PpidDataFilesService
func (_i *ppidDataFilesService) All(req request.PpidDataFilesQueryRequest) (ppidDataFiless []*response.PpidDataFilesResponse, paging paginator.Pagination, err error) {
	results, paging, err := _i.Repo.GetAll(req)
	if err != nil {
		return
	}

	for _, result := range results {
		ppidDataFiless = append(ppidDataFiless, mapper.PpidDataFilesResponseMapper(result))
	}

	return
}

func (_i *ppidDataFilesService) Show(id uint) (ppidDataFiles *response.PpidDataFilesResponse, err error) {
	result, err := _i.Repo.FindOne(id)
	if err != nil {
		return nil, err
	}

	return mapper.PpidDataFilesResponseMapper(result), nil
}

func (_i *ppidDataFilesService) Save(c *fiber.Ctx) (err error) {

	id, err := strconv.ParseUint(c.Params("ppidDataId"), 10, 0)
	if err != nil {
		return err
	}

	bucketName := _i.MinioStorage.Cfg.ObjectStorage.MinioStorage.BucketName

	form, err := c.MultipartForm()
	if err != nil {
		return err
	}
	files := form.File["files"]

	// Create minio connection.
	minioClient, err := _i.MinioStorage.ConnectMinio()
	if err != nil {
		// Return status 500 and minio connection error.
		return c.Status(fiber.StatusInternalServerError).JSON(fiber.Map{
			"error": true,
			"msg":   err.Error(),
		})
	}

	// Iterasi semua file yang diunggah
	for _, file := range files {

		_i.Log.Info().Str("timestamp", time.Now().
			Format(time.RFC3339)).Str("Service:Resource", "Uploader:: loop1").
			Interface("data", file).Msg("")

		src, err := file.Open()
		if err != nil {
			return err
		}
		defer src.Close()

		filename := filepath.Base(file.Filename)
		filenameWithoutExt := filepath.Clean(filename[:len(filename)-len(filepath.Ext(filename))])
		extension := filepath.Ext(file.Filename)[1:]

		rand.New(rand.NewSource(time.Now().UnixNano()))
		randUniqueId := rand.Intn(1000000)

		newFilenameWithoutExt := filenameWithoutExt + "_" + strconv.Itoa(randUniqueId)
		newFilename := newFilenameWithoutExt + "." + extension

		objectName := "ppid/upload/" + newFilename
		size := strconv.FormatInt(file.Size, 10)
		statusId := 1

		req := request.PpidDataFilesCreateRequest{
			PpidDataId: int(id),
			Title:      &newFilenameWithoutExt,
			FileType:   &extension,
			FileName:   &newFilename,
			FilePath:   &objectName,
			Size:       &size,
			StatusId:   &statusId,
		}

		err = _i.Repo.Create(req.ToEntity())
		if err != nil {
			return err
		}

		// Upload file ke MinIO
		_, err = minioClient.PutObject(context.Background(), bucketName, objectName, src, file.Size, minio.PutObjectOptions{})
		if err != nil {
			return err
		}
	}

	_i.Log.Info().Str("timestamp", time.Now().
		Format(time.RFC3339)).Str("Service:Resource", "User:All").
		Interface("data", "Successfully uploaded").Msg("")

	return
}

func (_i *ppidDataFilesService) Update(id uint, req request.PpidDataFilesUpdateRequest) (err error) {
	_i.Log.Info().Interface("data", req).Msg("")
	return _i.Repo.Update(id, req.ToEntity())
}

func (_i *ppidDataFilesService) Delete(id uint) error {
	return _i.Repo.Delete(id)
}

func (_i *ppidDataFilesService) Viewer(c *fiber.Ctx, filename string) (err error) {
	result, err := _i.Repo.FindByFilename(filename)
	if err != nil {
		return err
	}

	if result.FilePath == nil {
		return nil
	}

	ctx := context.Background()
	bucketName := _i.MinioStorage.Cfg.ObjectStorage.MinioStorage.BucketName
	objectName := result.FilePath

	_i.Log.Info().Str("timestamp", time.Now().
		Format(time.RFC3339)).Str("Service:Resource", "Article:Uploads").
		Interface("data", objectName).Msg("")

	// Create minio connection.
	minioClient, err := _i.MinioStorage.ConnectMinio()
	if err != nil {
		// Return status 500 and minio connection error.
		return c.Status(fiber.StatusInternalServerError).JSON(fiber.Map{
			"error": true,
			"msg":   err.Error(),
		})
	}

	fileContent, err := minioClient.GetObject(ctx, bucketName, *objectName, minio.GetObjectOptions{})
	if err != nil {
		log.Fatalln(err)
	}
	defer fileContent.Close()

	// Tentukan Content-Type berdasarkan ekstensi file
	contentType := mime.TypeByExtension("." + getFileExtension(*objectName))
	if contentType == "" {
		contentType = "application/octet-stream" // fallback jika tidak ada tipe MIME yang cocok
	}

	c.Set("Content-Type", contentType)

	if _, err := io.Copy(c.Response().BodyWriter(), fileContent); err != nil {
		return err
	}

	return
}

func getFileExtension(filename string) string {
	// split file name
	parts := strings.Split(filename, ".")

	// jika tidak ada ekstensi, kembalikan string kosong
	if len(parts) == 1 || (len(parts) == 2 && parts[0] == "") {
		return ""
	}

	// ambil ekstensi terakhir
	return parts[len(parts)-1]
}
